<script lang="js">
import Vue from 'vue';
import { NextStepAlt, } from '../components/common/index.vue';
import {
  CustomerLogos,
  IntroBlock,
  BlurbGrid,
  FeatureShowcase,
  TabbedFeatures,
  TabbedCaseStudies,
  RecognitionSpotlight,
  HeroScrollGallery,
} from '../components/home/index.vue';
import { getPageMetadata } from '../common/meta';
import { getClient } from '~/plugins/contentful.js';
import {
  homepageHelper
} from '~/services/homepage/homepage.service';

export default Vue.extend({
  components: {
    CustomerLogos,
    NextStepAlt,
    IntroBlock,
    BlurbGrid,
    FeatureShowcase,
    TabbedFeatures,
    TabbedCaseStudies,
    RecognitionSpotlight,
    HeroScrollGallery,
  },
   async asyncData({ $content, params, i18n }) {


    const locale = i18n.locale === i18n.defaultLocale ? '' : i18n.locale;
    let doc; let codeSuggestions;
    // Default locale data - Contentful
    if (locale) {
      doc = await $content(locale, `index`, params.slug).fetch();
      codeSuggestions = await $content(`code-suggestions`).fetch();
    }
    else {
      doc = await getClient().getEntries({
        content_type: 'page',
        include: 10,
        'sys.id': `5h8SvwgmRDi4o9RduvBJO5`,
      })
      .then((query) => {
        const entryFields = query.items[0]?.fields;
        return homepageHelper(entryFields)
      })
      .catch(console.error);
    }
    return {doc,codeSuggestions,locale}
  },
  head() {
      const metaInfo = getPageMetadata(this.doc, this.$route.fullPath, this.$nuxtI18nHead({ addSeoAttributes: true }))

    return {
      ...metaInfo,
    };
  },
  mounted() {
    this.onResize();
    window.addEventListener('resize', this.onResize);
  },
  destroyed() {
    window.removeEventListener('resize', this.onResize);
  },
  methods: {
    onResize() {
      this.width = window.innerWidth;
    },
    onFreeTrialClick() {
      this.$refs.launchDarklyButtons.fireCustomEvent(
        'clicked-hero-redesign-free-trial-cta',
      );
    }

  },
});
</script>

<template>
  <div class="homepage-container">
    <HeroScrollGallery
      v-if="doc.hero_scroll_gallery"
      v-bind="doc.hero_scroll_gallery"
      @hero-free-trial-cta-click="onFreeTrialClick()"
    />
    <SlpContainer>
      <CustomerLogos :data="doc.customer_logos_block" />
    </SlpContainer>
    <IntroBlock :data="doc.intro_block" />

    <BlurbGrid :data="doc.blurb_grid" />

    <SlpContainer v-if="doc.feature_showcase">
      <FeatureShowcase :data="doc.feature_showcase" />
    </SlpContainer>
    <TabbedFeatures
      v-if="doc.tabbed_features"
      :data="doc.tabbed_features"
      :code-blocks="codeSuggestions?.code_blocks"
    />
    <TabbedCaseStudies v-bind="doc.quotes_carousel_block" />
    <RecognitionSpotlight
      v-if="doc.recognition_spotlight"
      :data="doc.recognition_spotlight"
    />

    <NextStepAlt :current-locale="locale" />
  </div>
</template>
<style scoped lang="scss">
.homepage-container {
  position: relative;
  background-image: url('/nuxt-images/home/gradient.png');
  background-repeat: no-repeat;
  background-size: 300% 1400px;
  background-position: center top;
  z-index: 1;
  overflow: hidden;
  @media (min-width: $breakpoint-sm) {
    background-size: 100% 1400px;
    background-position: right top;
  }

  &:before {
    content: '';
    position: absolute;
    width: 100%;
    height: 746px;
    left: 0;
    top: 700px;
    z-index: -1;
    background: linear-gradient(
      0deg,
      #fff 0%,
      #fff 24.59%,
      rgba(255, 255, 255, 0) 100%
    );
  }
}
</style>
